# GoodGit: Git for Humans

## Introduction 📚

Welcome to GoodGit, where mastering Git takes 4 minutes, not 4 years! Inspired by the community's frustrations ([Reddit discussion](https://www.reddit.com/r/webdev/comments/ffvsnf/unpopular_opinion_git_is_unintuitive_and_not_fun/)), GoodGit aims to make Git intuitive and user-friendly.

🎥 **Watch our [introductory video](https://www.goodgit.io/static/video.mp4) to get started!**

https://www.goodgit.io/static/video.mp4

## Features 🌟

-   **Simplified Commands**: Perform complex Git operations with simple, intuitive commands.
-   **AI-Powered Commit Messages**: Let AI write the world's best commit messages for you.
-   **SSH Setup**: Automate the tedious SSH setup process.
-   **Multi-Account Support**: Easily switch between different accounts. Just run the setup for each account you want to use.
-   **Search**: Easily find what you're looking for with GoodGit's search feature.
-   **Branching**: Stashing... what's that? Never think about stashing again while working with branches.
-   **Publish**: Add your project to GitHub without leaving your terminal.

## Upcoming Features 🚀

-   AI-based merge conflict resolution.
-   A GUI for even more user-friendliness.

## Prerequisites 🛠

-   Python
-   Pip
-   Internet Connection
-   A human who can type :)

## Installation 💻

`pip install goodgit`

## Usage 🛠️

Here are some of the most commonly used GoodGit commands:

Basic: Replace `git <command>` with `gg <command>`

-   Add files: `gg add <files to add>`
-   Commit changes: `gg commit`
-   Uncommit changes: `gg uncommit`
-   Time-travel through commit history: `gg timetravel` or `gg tt`
-   Apply a time-travelled commit: `gg tt apply`
-   Search: `gg search`
-   Create a new branch: `gg branch` or `gg b`
-   Setup SSH: `gg setup`
-   Publish to GitHub: `gg publish`
-   Open your repo in a browser: `gg web`

## Contributing 🤝

We welcome contributions from everyone. Feel free to open an issue or create a pull request. 
All ideas, problems, and feature requests are welcome :)